local meditation = Talents:getTalentFromId(Talents.T_MEDITATION)
local earths_eyes = Talents:getTalentFromId(Talents.T_EARTH_S_EYES)

-- activate() adds a new style ESP effect
meditation.activate = function(self, t)
	local ret = {}

	local pt = 2 + self:combatTalentMindDamage(t, 20, 120) / 10
	local save = 5 + self:combatTalentMindDamage(t, 10, 40)
	local heal = 5 + self:combatTalentMindDamage(t, 12, 30)

	if self:knowTalent(self.T_EARTH_S_EYES) then
		local te = self:getTalentFromId(self.T_EARTH_S_EYES)
		self:addTemporaryEsp("meditation", {all = te.radius_esp(self, te)})
	end

	game:playSoundNear(self, "talents/heal")
	self:talentTemporaryValue(ret, "equilibrium_regen", -pt)
	self:talentTemporaryValue(ret, "combat_mentalresist", save)
	self:talentTemporaryValue(ret, "healing_factor", heal / 100)
	self:talentTemporaryValue(ret, "numbed", 50)
	return ret
end

-- Make deactivate() remove the ESP effect
meditation.deactivate = function(self, t, p)
	self:removeTemporaryEsp("meditation")
	return true
end

-- No floor for the radius
earths_eyes.radius_esp = function(self, t) return 3 + self:getTalentLevel(t) / 2 end
earths_eyes.info = function(self, t)
	local radius = self:getTalentRadius(t)
	local radius_esp = math.floor(t.radius_esp(self, t))
	return ([[Using your connection to Nature you can see your surrounding area in a radius of %d.
	Also while meditating you are able to detect the presence of creatures around you in a radius %d.]]):
	format(radius, radius_esp)
end