local Esp = require "mod.class.interface.ActorEsp"
local mindlink = Talents:getTalentFromId(Talents.T_MIND_LINK)

mindlink.activate = function(self, t)
	local tg = self:getTalentTarget(t)
	local x, y = self:getTarget(tg)
	if not x or not y then return nil end
	local _ _, x, y = self:canProject(tg, x, y)
	local target = game.level.map(x, y, Map.ACTOR)
	if not target or target == self then return end

	target:setEffect(target.EFF_MIND_LINK_TARGET, 10, {power=t.getBonusDamage(self, t), src=self, range=self:getTalentRange(t)*2})

	game.level.map:particleEmitter(self.x, self.y, 1, "generic_discharge", {rm=0, rM=0, gm=100, gM=180, bm=180, bM=255, am=35, aM=90})
	game.level.map:particleEmitter(target.x, target.y, 1, "generic_discharge", {rm=0, rM=0, gm=100, gM=180, bm=180, bM=255, am=35, aM=90})
	game:playSoundNear(self, "talents/echo")

	local ret = {
		target = target,
	}
	self:addTemporaryEsp("mindlink", target.type)

	-- Update for ESP
	game:onTickEnd(function() 
		self:resetCanSeeCache()
	end)

	return ret
end

mindlink.deactivate = function(self, t, p)
	-- Break 'both' mind links if we're projecting
	if self:attr("is_psychic_projection") and self.summoner:isTalentActive(self.summoner.T_MIND_LINK) then
		self.summoner:forceUseTalent(self.summoner.T_MIND_LINK, {ignore_energy=true})
	end
	self:removeTemporaryEsp("mindlink")

	return true
end